#pylint: disable=C0103,C0301,F0401,R0911

"""This is the server's authentication service"""

from flask import Flask, request, session, jsonify
app = Flask(__name__)

import service_keys
from Crypto.PublicKey import RSA
AUTH_SVC_PRIVATE_KEY = RSA.importKey('-----BEGIN RSA PRIVATE KEY-----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\n-----END RSA PRIVATE KEY-----')
import collections
import time
import uuid
import base64

# because the client and server are running on the same computer (right now),
# the lib directory is located elsewhere, and we have to hack $PATH to find it
import sys
sys.path.append('../lib')
from pwgen_lib import encrypt_and_sign_dict, verify_and_decrypt_dict

import srp
import srp_patches
srp_patches.patch() # monkeypatch!

# right now, store all data in-memory (because this is just a proof-of-concept)
approved_passwords = collections.defaultdict(dict)
srp_data = {}
srp_temp_data = {}

@app.route('/approve/1', methods=['POST'])
def approve1():
    """The first of two approval messages from the generation service"""

    session.clear() # reset session

    data = verify_and_decrypt_dict(request.data, AUTH_SVC_PRIVATE_KEY, service_keys.GEN_SVC_PUBLIC_KEY)
    # store data only in the session cookie until we have the second message
    session['username'] = data['username']
    session['commitment_P'] = data['commitment_P']
    session['timestamp'] = data['timestamp']

    return "ok"

@app.route('/approve/2', methods=['POST'])
def approve2():
    """The second of two approval messages from the generation service"""

    data = request.json

    if data['username'] != session['username']:
        raise Exception

    username = data['username']
    commitment_P = session['commitment_P']

    # store the approved password in the in-memory "database"
    approved_passwords[username][commitment_P] = dict(
        timestamp = session['timestamp'],
        public_key = data['public_key'],
    )

    return "ok"

@app.route('/register', methods=['POST'])
def register():
    """
    A user attempting to register must send their username, commitment_P, and
    public_key. We will verify that this (username, commitment_P, public_key)
    tuple has been approved by the generation service and, if so, let the user
    register by returning an "authentication token." The authentication token
    is simply an encrypted message giving the user permission to login, which
    only the bank_main service can read. This is a hack, and it has to do with
    the fact that (a) we don't have inter-service communication, and (b) we're
    using Flask session cookies, but these follow the same-origin policy, and
    the current proof-of-concept site has bank_auth and bank_main on different
    ports, meaning that providing the user with a cookie at this step would be
    useless.
    """

    data = request.json
    username = data['username']
    commitment_P = data['commitment_P']
    if username not in approved_passwords:
        return "fail"
    if commitment_P not in approved_passwords[username]:
        return "fail"
    timestamp = approved_passwords[username][commitment_P]["timestamp"]
    # approved passwords expire if not registered within 60 seconds
    if time.time() - timestamp > 60:
        return "fail"

    public_key = approved_passwords[username][commitment_P]["public_key"]
    client_public_key = data['public_key']
    # make sure that the client and server both agreed about the public key,
    # otherwise one is lying
    if public_key['q'] != client_public_key['q']:
        return "fail"
    if public_key['p'] != client_public_key['p']:
        return "fail"
    if public_key['y'] != client_public_key['y']:
        return "fail"

    # create and store the vkey that SRP will use
    salt, vkey = srp.create_salted_verification_key(commitment_P, public_key['q'], ng_type=srp.NG_CUSTOM, n_hex=hex(public_key['p']), g_hex=hex(public_key['y']))
    srp_data[username] = dict(
        salt = salt,
        vkey = vkey,
        public_key = public_key,
    )

    ret_data = dict(
        username = username,
        logged_in = True,
    )
    return encrypt_and_sign_dict(ret_data, AUTH_SVC_PRIVATE_KEY, service_keys.MAIN_SVC_PUBLIC_KEY)

@app.route('/login/1', methods=['POST'])
def login1():
    """Step 1 of SRP: the user provides a username, and we respond with the user's public key"""

    session.clear() # reset session
    ret_data = {}

    data = request.json
    username = data['username']

    uid = str(uuid.uuid4())
    session['uuid'] = uid
    session['username'] = username

    if username in srp_data:
        ret_data = srp_data[username]['public_key']

    return jsonify(ret_data)

@app.route('/login/2', methods=['POST'])
def login2():
    """Step 2 of SRP: the user sends A, and we respond with s and B"""

    ret_data = {}
    username = session['username']
    uid = session['uuid']

    data = request.json

    salt = srp_data[username]['salt']
    vkey = srp_data[username]['vkey']
    public_key = srp_data[username]['public_key']

    A = base64.b64decode(data['A'])
    svr = srp.Verifier(username, salt, vkey, A, ng_type=srp.NG_CUSTOM, n_hex=hex(public_key['p']), g_hex=hex(public_key['y']))
    s, B = svr.get_challenge()
    if s is not None and B is not None:
        ret_data = dict(
            s = base64.b64encode(s),
            B = base64.b64encode(B),
        )

    srp_temp_data[uid] = dict(
        svr = svr,
    )
    return jsonify(ret_data)

@app.route('/login/3', methods=['POST'])
def login3():
    """
    Step 3 of SRP: the user provides M, and we respond with HAMK and (if
    successful) an authentication token
    """

    ret_data = {}
    username = session['username']
    uid = session['uuid']
    svr = srp_temp_data[uid]['svr']

    data = request.json

    M = base64.b64decode(data['M'])
    HAMK = svr.verify_session(M)
    if HAMK is not None and svr.authenticated():
        token = dict(
            username = username,
            logged_in = True,
        )
        ret_data = dict(
            HAMK = base64.b64encode(HAMK),
            token = encrypt_and_sign_dict(token, AUTH_SVC_PRIVATE_KEY, service_keys.MAIN_SVC_PUBLIC_KEY),
        )

    return jsonify(ret_data)

# Flask requires a secret key in order to make encrypted session cookies
app.secret_key = '\x90/8\xb8\x82,\xb7\xeftFQ\xd2\xae\xeb\xad!\xbdD\x95\xb7\xcd7\xbd\x9a'

if __name__ == '__main__':
    app.run(port=8082, debug=True)
