#pylint: disable=C0103,C0301,E1101

"""
This is the server's password generation/"verification" service. We call it a
verification service because, after providing randomness to the client, we
verify (using a zero-knowledge proof) that the client did in fact incorporate
the randomness we provided.
"""

from pwgen_server import ServerPasswordGenerator
import uuid
import requests
import json

from flask import Flask, request, session, jsonify
app = Flask(__name__)

from Crypto.PublicKey import RSA
GEN_SVC_PRIVATE_KEY = RSA.importKey('-----BEGIN RSA PRIVATE KEY-----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\nfZ5IUHGFZMbqiNX2b1+LMYOx+MRBsPLaACq4toEsgqpsKzCpJ76lwPjwuac=\n-----END RSA PRIVATE KEY-----')

# right now, store all data in-memory (because this is just a proof-of-concept)
generators = {}

@app.route('/generate/1', methods=['POST'])
def step1():
    """The client provides a username, and we respond with a partial public key"""

    session.clear() # reset session

    uid = str(uuid.uuid4())
    session['uuid'] = uid

    data = request.json
    gen = ServerPasswordGenerator(data['username'])
    generators[uid] = gen

    return jsonify(dict(
        partial_public_key = gen.get_public_key(),
    ))

@app.route('/generate/2', methods=['POST'])
def step2():
    """The client completes the public key, and we respond with a commitment ot S"""

    gen = generators[session['uuid']]
    data = request.json
    gen.modify_private_key(data['f_client_private_key'])

    return jsonify(dict(
        commitment_S = gen.generate_commitment_s(),
    ))

@app.route('/generate/3', methods=['POST'])
def step3():
    """The client provides a commitment to C, and we respond by revealing S"""

    gen = generators[session['uuid']]
    data = request.json
    gen.store_commitment_c(data['commitment_C'])

    return jsonify(dict(
        reveal_S = gen.reveal_s(),
    ))

@app.route('/generate/4', methods=['POST'])
def step4():
    """
    In a single step (to avoid more round trips), the client provides a
    commitment to P, a commitment to C+P-S, and reveals that C+P-S has value
    0. In response, we send the now-approved commitment_P to the
    authentication service, and we send our part of the private key to the
    client. (Since the protocol is over, it doesn't hurt us for the client to
    have the full private key, and in fact the client now needs it to generate
    an SRP-ready password.)
    """

    gen = generators[session['uuid']]
    data = request.json

    gen.store_commitment_p(data['commitment_P'])
    gen.verify_commitment_zero(data['commitment_zero'])
    gen.verify_reveal_zero(data['reveal_zero'])

    # send to the authentication service
    approve_password(gen)

    return jsonify(dict(
        password_accepted = True,
        server_private_key = gen.private_key,
    ))

def approve_password(gen):
    """
    Send a message to the authentication service indicating that this
    commitment_P (with associated public_key) is approved for this user. See
    the docstring for get_approval_messages in pwgen_server.py for some
    caveats and commentary.
    """

    payload1, payload2 = gen.get_approval_messages(GEN_SVC_PRIVATE_KEY)

    s = requests.Session() # this will open a cookiejar
    r = s.post("http://localhost:8082/approve/1", data=payload1)

    if r.status_code != requests.codes.ok:
        raise Exception
    if r.text != "ok":
        raise Exception

    headers = {'content-type': 'application/json'}
    r = s.post("http://localhost:8082/approve/2", data=json.dumps(payload2), headers=headers)

    if r.status_code != requests.codes.ok:
        raise Exception
    if r.text != "ok":
        raise Exception

# Flask requires a secret key in order to make encrypted session cookies
app.secret_key = '\xbah\xed\xb7\xdb\xed\xa8\x03_\xf9\x92!:\x16XZ\x9fE%\xdd=\xd1i\xde'

if __name__ == '__main__':
    app.run(port=8081, debug=True)
